Graph
SPA

Node graph. More...

## Files

file | graph.h
| `spa/graph/graph.h`

## Data Structures

struct | spa_graph_state
struct | spa_graph_link
struct | spa_graph
struct | spa_graph_node_callbacks
struct | spa_graph_node
struct | spa_graph_port

## Macros

#define | spa_debug(...)
#define | spa_graph_link_signal(l) ((l)->signal((l)->signal_data))
#define | spa_graph_state_dec(s, c) (__atomic_sub_fetch(&(s)->pending, c, __ATOMIC_SEQ_CST) == 0)
#define | SPA_VERSION_GRAPH_NODE_CALLBACKS 0
#define | spa_graph_node_call(n, method, version, ...)
#define | spa_graph_node_process(n) spa_graph_node_call(n, process, 0, n)
#define | spa_graph_node_reuse_buffer(n, p, i) spa_graph_node_call(n, reuse_buffer, 0, n, p, i)

## Functions

static void | spa_graph_state_reset (struct spa_graph_state *state)
static int | spa_graph_link_trigger (struct spa_graph_link *link)
static int | spa_graph_node_trigger (struct spa_graph_node *node)
static int | spa_graph_run (struct spa_graph *graph)
static int | spa_graph_finish (struct spa_graph *graph)
static int | spa_graph_link_signal_node (void *data)
static int | spa_graph_link_signal_graph (void *data)
static void | spa_graph_init (struct spa_graph *graph, struct spa_graph_state *state)
static void | spa_graph_link_add (struct spa_graph_node *out, struct spa_graph_state *state, struct spa_graph_link *link)
static void | spa_graph_link_remove (struct spa_graph_link *link)
static void | spa_graph_node_init (struct spa_graph_node *node, struct spa_graph_state *state)
static int | spa_graph_node_impl_sub_process (void *data, struct spa_graph_node *node)
static void | spa_graph_node_set_subgraph (struct spa_graph_node *node, struct spa_graph *subgraph)
static void | spa_graph_node_set_callbacks (struct spa_graph_node *node, const struct spa_graph_node_callbacks *callbacks, void *data)
static void | spa_graph_node_add (struct spa_graph *graph, struct spa_graph_node *node)
static void | spa_graph_node_remove (struct spa_graph_node *node)
static void | spa_graph_port_init (struct spa_graph_port *port, enum spa_direction direction, uint32_t port_id, uint32_t flags)
static void | spa_graph_port_add (struct spa_graph_node *node, struct spa_graph_port *port)
static void | spa_graph_port_remove (struct spa_graph_port *port)
static void | spa_graph_port_link (struct spa_graph_port *out, struct spa_graph_port *in)
static void | spa_graph_port_unlink (struct spa_graph_port *port)
static int | spa_graph_node_impl_process (void *data, struct spa_graph_node *node)
static int | spa_graph_node_impl_reuse_buffer (void *data, struct spa_graph_node *node, uint32_t port_id, uint32_t buffer_id)

## Variables

static const struct spa_graph_node_callbacks | spa_graph_node_sub_impl_default
static const struct spa_graph_node_callbacks | spa_graph_node_impl_default

## Detailed Description

Node graph.

## Macro Definition Documentation

## spa_debug

#define spa_debug | ( |  | ... | ) |

## spa_graph_link_signal

#define spa_graph_link_signal | ( |  | l | ) | ((l)->signal((l)->signal_data))

## spa_graph_state_dec

#define spa_graph_state_dec | ( |  | s,
|  |  | c
| ) |  | (__atomic_sub_fetch(&(s)->pending, c, __ATOMIC_SEQ_CST) == 0)

## SPA_VERSION_GRAPH_NODE_CALLBACKS

#define SPA_VERSION_GRAPH_NODE_CALLBACKS 0

## spa_graph_node_call

#define spa_graph_node_call | ( |  | n,
|  |  | method,
|  |  | version,
|  |  | ...
| ) |  |

## spa_graph_node_process

#define spa_graph_node_process | ( |  | n | ) | spa_graph_node_call(n, process, 0, n)

Examples
  spa/examples/adapter-control.c, and spa/examples/example-control.c.

## spa_graph_node_reuse_buffer

#define spa_graph_node_reuse_buffer | ( |  | n,
|  |  | p,
|  |  | i
| ) |  | spa_graph_node_call(n, reuse_buffer, 0, n, p, i)

## Function Documentation

## spa_graph_state_reset()

static void spa_graph_state_reset | ( | struct spa_graph_state * | state | ) |

inline static

## spa_graph_link_trigger()

static int spa_graph_link_trigger | ( | struct spa_graph_link * | link | ) |

inline static

## spa_graph_node_trigger()

static int spa_graph_node_trigger | ( | struct spa_graph_node * | node | ) |

inline static

## spa_graph_run()

static int spa_graph_run | ( | struct spa_graph * | graph | ) |

inline static

## spa_graph_finish()

static int spa_graph_finish | ( | struct spa_graph * | graph | ) |

inline static

## spa_graph_link_signal_node()

static int spa_graph_link_signal_node | ( | void * | data | ) |

inline static

## spa_graph_link_signal_graph()

static int spa_graph_link_signal_graph | ( | void * | data | ) |

inline static

## spa_graph_init()

static void spa_graph_init | ( | struct spa_graph * | graph,
|  | struct spa_graph_state * | state
| ) |  |

inline static

Examples
  spa/examples/adapter-control.c, and spa/examples/example-control.c.

## spa_graph_link_add()

static void spa_graph_link_add | ( | struct spa_graph_node * | out,
|  | struct spa_graph_state * | state,
|  | struct spa_graph_link * | link
| ) |  |

inline static

## spa_graph_link_remove()

static void spa_graph_link_remove | ( | struct spa_graph_link * | link | ) |

inline static

## spa_graph_node_init()

static void spa_graph_node_init | ( | struct spa_graph_node * | node,
|  | struct spa_graph_state * | state
| ) |  |

inline static

Examples
  spa/examples/adapter-control.c, and spa/examples/example-control.c.

## spa_graph_node_impl_sub_process()

static int spa_graph_node_impl_sub_process | ( | void * | data,
|  | struct spa_graph_node * | node
| ) |  |

inline static

## spa_graph_node_set_subgraph()

static void spa_graph_node_set_subgraph | ( | struct spa_graph_node * | node,
|  | struct spa_graph * | subgraph
| ) |  |

inline static

## spa_graph_node_set_callbacks()

static void spa_graph_node_set_callbacks | ( | struct spa_graph_node * | node,
|  | const struct spa_graph_node_callbacks * | callbacks,
|  | void * | data
| ) |  |

inline static

Examples
  spa/examples/adapter-control.c, and spa/examples/example-control.c.

## spa_graph_node_add()

static void spa_graph_node_add | ( | struct spa_graph * | graph,
|  | struct spa_graph_node * | node
| ) |  |

inline static

Examples
  spa/examples/adapter-control.c, and spa/examples/example-control.c.

## spa_graph_node_remove()

static void spa_graph_node_remove | ( | struct spa_graph_node * | node | ) |

inline static

## spa_graph_port_init()

static void spa_graph_port_init | ( | struct spa_graph_port * | port,
|  | enum spa_direction | direction,
|  | uint32_t | port_id,
|  | uint32_t | flags
| ) |  |

inline static

Examples
  spa/examples/adapter-control.c, and spa/examples/example-control.c.

## spa_graph_port_add()

static void spa_graph_port_add | ( | struct spa_graph_node * | node,
|  | struct spa_graph_port * | port
| ) |  |

inline static

Examples
  spa/examples/adapter-control.c, and spa/examples/example-control.c.

## spa_graph_port_remove()

static void spa_graph_port_remove | ( | struct spa_graph_port * | port | ) |

inline static

## spa_graph_port_link()

static void spa_graph_port_link | ( | struct spa_graph_port * | out,
|  | struct spa_graph_port * | in
| ) |  |

inline static

Examples
  spa/examples/adapter-control.c, and spa/examples/example-control.c.

## spa_graph_port_unlink()

static void spa_graph_port_unlink | ( | struct spa_graph_port * | port | ) |

inline static

## spa_graph_node_impl_process()

static int spa_graph_node_impl_process | ( | void * | data,
|  | struct spa_graph_node * | node
| ) |  |

inline static

## spa_graph_node_impl_reuse_buffer()

static int spa_graph_node_impl_reuse_buffer | ( | void * | data,
|  | struct spa_graph_node * | node,
|  | uint32_t | port_id,
|  | uint32_t | buffer_id
| ) |  |

inline static

## Variable Documentation

## spa_graph_node_sub_impl_default

const struct spa_graph_node_callbacks spa_graph_node_sub_impl_default

static

## spa_graph_node_impl_default

const struct spa_graph_node_callbacks spa_graph_node_impl_default

static

Examples
  spa/examples/adapter-control.c, and spa/examples/example-control.c.